import React, { ComponentType } from 'react';
import { ThemeOptions } from '../../components/theme/ThemeContext';
import { BaseCSSProperties, SelectorCSSProperties } from '../../utils/makeStyles';
import { SxPalette } from './palette';
import { SxSizing } from './sizing';
import { SxSpace } from './space';
import { SxTypography } from './typography';
export type SxStyleProps = React.CSSProperties | SxSpace | SxPalette | SxSizing | SxTypography | {
    shadow?: number | string;
};
type SxCallBack = (theme: ThemeOptions) => BaseCSSProperties | SelectorCSSProperties;
export type SxProps = SxCallBack | BaseCSSProperties | SelectorCSSProperties | {
    [key: string]: any;
};
export type WithSxProps = {
    className?: string;
    sx?: SxProps;
    ref?: React.Ref<HTMLElement>;
};
export declare function withSx<TProps>(Component: ComponentType<TProps>): React.ForwardRefExoticComponent<React.PropsWithoutRef<TProps & WithSxProps> & React.RefAttributes<unknown>>;
export default withSx;
